import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCardEditLog, ThinkCardEditLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询IC卡编辑日志
 */
export async function pageThinkCardEditLog(params: ThinkCardEditLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCardEditLog>>>(
    THINK_API_URL + '/think/think-card-edit-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询IC卡编辑日志列表
 */
export async function listThinkCardEditLog(params?: ThinkCardEditLogParam) {
  const res = await request.get<ApiResult<ThinkCardEditLog[]>>(
    THINK_API_URL + '/think/think-card-edit-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加IC卡编辑日志
 */
export async function addThinkCardEditLog(data: ThinkCardEditLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-edit-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改IC卡编辑日志
 */
export async function updateThinkCardEditLog(data: ThinkCardEditLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-edit-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除IC卡编辑日志
 */
export async function removeThinkCardEditLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-edit-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除IC卡编辑日志
 */
export async function removeBatchThinkCardEditLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-edit-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询IC卡编辑日志
 */
export async function getThinkCardEditLog(id: number) {
  const res = await request.get<ApiResult<ThinkCardEditLog>>(
    THINK_API_URL + '/think/think-card-edit-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
